;**************************************************************************
MySetTextColor proc foregnd :DWORD, backgnd :DWORD
    mov eax, backgnd                       ; get background colour
    shl eax, 4
    or eax, foregnd                        ; get foreground colour
    invoke SetConsoleTextAttribute, hConsoleOutput, eax
    ret
MySetTextColor endp
; -------------------------------------------------------------------------
MySetScreenColor proc foregnd :DWORD, backgnd :DWORD
    LOCAL noc :DWORD
    LOCAL cnt :DWORD
    LOCAL sbi :CONSOLE_SCREEN_BUFFER_INFO

    invoke GetConsoleScreenBufferInfo, hConsoleOutput, ADDR sbi
    mov eax, sbi.dwSize                 ; 2 word values returned for screen size
    push ax
    rol eax, 16
    mov cx, ax
    pop ax
    mul cx
    cwde
    mov cnt, eax
    mov edx, backgnd
    shl edx, 4
    or edx, foregnd
    invoke FillConsoleOutputAttribute, hConsoleOutput, edx, cnt, NULL, ADDR noc
    ret
MySetScreenColor endp
; -------------------------------------------------------------------------
MySetCellColor proc foregnd :DWORD, backgnd :DWORD, x :DWORD, y :DWORD, n :DWORD
    LOCAL noc :DWORD
    LOCAL coord :DWORD

    mov edx, backgnd                    ; get background colour
    shl edx, 4                          ; mov it into bits 4 to 7
    or edx, foregnd                     ; foregound colour in Lo 4 bits
    mov ecx, x                          ; get column
    mov eax, y                          ; get row
    shl eax, 16                         ; mov into Hi 16 bits (row)
    mov ax, cx                          ; mov into Lo 16 bits (column)
    mov coord, eax                      ; prime co ordinate
    mov ecx, n                          ; number of character cells
    invoke FillConsoleOutputAttribute, hConsoleOutput, edx, ecx, coord, ADDR noc
    ret
MySetCellColor endp
; -------------------------------------------------------------------------
MySetSmallRect proc ps_r :DWORD, left :DWORD, top :DWORD, right :DWORD, bottom :DWORD
    mov edx, ps_r
    mov eax, left
    mov [edx].SMALL_RECT.Left, ax
    mov eax, top
    mov [edx].SMALL_RECT.Top, ax
    mov eax, right
    mov [edx].SMALL_RECT.Right, ax
    mov eax, bottom
    mov [edx].SMALL_RECT.Bottom, ax
    ; -------------------------------------------------------------------------
    ; The SetConsoleWindowInfo function sets the current size and position of a console screen buffer's window.
    ; -------------------------------------------------------------------------
    invoke SetConsoleWindowInfo, hConsoleOutput, TRUE, ADDR small_rect
    ret
MySetSmallRect endp
; -------------------------------------------------------------------------
MyHideCursor proc
    invoke GetConsoleCursorInfo, hConsoleOutput, addr cci
    mov cci.dwSize, 1
    mov cci.bVisible, FALSE
    invoke SetConsoleCursorInfo, hConsoleOutput, addr cci
    ret
MyHideCursor endp
; -------------------------------------------------------------------------
MyShowCursor proc
    invoke GetConsoleCursorInfo, hConsoleOutput, addr cci
    mov cci.dwSize, 100
    mov cci.bVisible, TRUE
    invoke SetConsoleCursorInfo, hConsoleOutput, addr cci
    ret
MyShowCursor endp
; -------------------------------------------------------------------------
MyClearScreen proc
    invoke MySetScreenColor, 0, 0
    cls
    invoke MySetTextColor, light_green, 0
    loc 32, 0
    print "Esc"
    invoke MySetTextColor, light_magenta, 0
    loc 26, 0
    print "Press"
    loc 36, 0  
    print "To Cancel / Return"
    ret
MyClearScreen endp
; -------------------------------------------------------------------------
MyBackSpace proc
    ret
MyBackSpace endp
; -------------------------------------------------------------------------
MyBlankLine proc Col_Val :Byte, Row_Val :Byte
    loc Col_Val, Row_Val
    invoke MySetTextColor, 0, 0
    print "                                                            "
    ret
MyBlankLine endp
; -------------------------------------------------------------------------
MyActivatekey proc
    invoke MyClearScreen        ; print 'Esc' etc on top row
    cmp infmt, 1              ; only 1 match?
    jne @F                    ; no, goto activate key
    ret                       ; yes, ignore
@@:
    invoke MySetTextColor, yellow, 0
    loc 22, 18                ; column 22 row 18
    print "Use Spacebar to step through matches"
    ret
MyActivatekey endp
; -------------------------------------------------------------------------
MyLeadingZero proc
    movzx eax, BYTE PTR[esi]  ; get number
    inc esi                   ; point at next number
lzero2:
    cmp eax, 9                ; is <10 ?
    ja @F                     ; no, bypass leading zero
    push eax                  ; yes, save number
    print "0"                 ; display leading zero
    pop eax                   ; restore number
@@:
    print ustr$(eax)          ; display number
    ret
MyLeadingZero endp
; -------------------------------------------------------------------------
