Comment # ---------------------------------------------------
See NFact.pdf - provided by dedndave

procedure GetMultiplicity( OriginalInteger : longint;
PrimeDivisor : longint;
var Multiplicity : longint);
var ScratchInteger : longint;
begin
   ScratchInteger := OriginalInteger;
   Multiplicity := 0;
   repeat
      ScratchInteger := INT(ScratchInteger/PrimeDivisor);
      inc(Multiplicity, ScratchInteger)
   until ScratchInteger=0
end;

Note: In the range of 64K we have the following:

           Numbers     Primes
             65536       6542
             20000       2262
               500         95

----------------------------------------------------------- #
; 
Get_Multiplicity proc Org_Integer :DWORD, Prime_Divisor :DWORD, ptrMultiplicity :DWORD
LOCAL Scratch_Integer :DWORD
    push eax
    push ebx
    push ecx
    push edx
    push esi
    push edi
         mov eax, Org_Integer
         mov ebx, Prime_Divisor
         mov esi, ptrMultiplicity

         mov Scratch_Integer, eax                   ; Setup Scratch_Integer with Original Integer

         xor eax, eax                               ; Initialize to zero
         mov [esi], eax                             ; Save Zero to Multiplicity

         .repeat
             xor edx, edx                           ; Clear the way for dividing
             mov eax, Scratch_Integer               ; Setup Dividend
             div ebx                                ; Divide by Prime_Divisor, the quotient is placed in eax, and the remainder is placed in edx
             mov ecx, [esi]                         ; Get Multiplicity value
             add ecx, eax                           ; Increment value
             mov [esi], ecx                         ; Save Multiplicity value
             mov Scratch_Integer, eax               ; Get Integer portion of divide
         .until Scratch_Integer == 0                ; Zero indicates we have reached the end
    pop edi
    pop esi
    pop edx
    pop ecx
    pop ebx
    pop eax
    ret
Get_Multiplicity endp
; 
